<template>

<Box v-if="thresholds" v-bind:title="$t('threshold')" v-bind:startsOpen="startsOpen" v-on:toggle="$emit('toggle', $event)">
    <DropdownBase
        v-on:input="updateCurrentThreshold($event)"
        class="
        flex-1
    ">
        <option
            v-bind:key="key"
            v-for="(value, key) in thresholds.list"
            v-bind:selected="thresholds.list[key].name === thresholds.current.name"
        >
            {{ $t(value.name) }}
        </option>
    </DropdownBase>

    <BoxThresholdOther v-if="thresholds.current.name === 'other'"/>

    <div
        class="
        border-3
        lg:border-4
        bg-gray-200
        dark:bg-cgray-800
        border-gray-200
        dark:border-cgray-800
        rounded-lg
        px-2
        lg:px-4
        py-2
        mt-2
    ">
        <ValuesColor colorName="goodColor">
            0 &lt; {{ project.reports.current.values.current}} &lt; {{thresholds.current.goodValue.value}}
        </ValuesColor>

        <ValuesColor
            v-if="thresholds.current.state == 2"
            colorName="middleColor"
            class="pt-4"
        >
            {{thresholds.current.goodValue.value}} &lt; {{ project.reports.current.values.current}} &lt; {{thresholds.current.badValue.value}}
        </ValuesColor>

        <ValuesColor colorName="badColor" class="pt-4">
            {{thresholds.current.badValue.value}} &lt; {{project.reports.current.values.current}} &lt; ∞
        </ValuesColor>
    </div>
</Box>

</template>

<script lang='ts'>

import { Component, Prop, Vue } from 'vue-property-decorator';
import { State } from 'vuex-class';

import { Project } from '@/ts/project';
import { Threshold } from '@/ts/threshold';

import DropdownBase from '@/components/DropdownBase.vue';
import IconBase from '@/components/IconBase.vue';
import Box from '@/components/Box.vue';

import BoxThresholdOther from './components/BoxThresholdOther/index.vue';
import ValuesColor from './components/ValuesColor.vue';

@Component({
    components: {
        Box,
        BoxThresholdOther,
        DropdownBase,
        IconBase,
        ValuesColor,
    },
})
export default class C extends Vue {
    @State('project')
    private project!: Project;

    @Prop({ default: false })
    private startsOpen!: boolean;

    private thresholds: CurrentList<Threshold> | null = null;

    private mounted() {
        if (
            this.project
            && this.project.reports
            && this.project.reports.current
            && this.project.reports.current.thresholds
        ) {
            this.thresholds = this.project.reports.current.thresholds;
        }
    }

    private updateCurrentThreshold(name: string): void {
        if (this.thresholds) {
            this.thresholds.list.forEach((threshold: Threshold) => {
                if (this.thresholds && this.$t(threshold.name) === name) {
                    this.thresholds.current = threshold;

                    if (name !== this.$t('other')) {
                        this.thresholds.list[this.thresholds.list.length - 1].goodValue.value.setNumber(threshold.goodValue.value.toNumber());
                        this.thresholds.list[this.thresholds.list.length - 1].badValue.value.setNumber(threshold.goodValue.value.toNumber());
                    }
                    this.project.update();
                }
            });
        }
    }
}

</script>
